--This is a Lua file, to control operation of the "IWR" simple renderer.
--For info on programming Lua, you should, er, find the Lua documentation!
--Or you can look at the default functions given here for examples.


-- you define get_texture(x,y,z) to return 3 values that
-- represent the r,g,b components of the texture found
-- at (x,y,z). This should be obvious!!

function get_texture (x,y,z)
  l=sin((z*180)/16)
  l=(l+1)/2.8;
  r=127+((255-127)*l);
  g=96+((255-96)*l);
  b=16+((255-16)*l);
--NOTE: Need to export the C functions such as iwr_whiteout()
-- and iwr_unfade() into lua for this to use.
-- Also need to give functions for 1d,2d, and 3d perlin noise
-- (needs to be deterministic, which will be difficult), and
-- for registering image files for texturing, and then getting
-- pixels from preregistered images.
-- These should collectively give about as much as most texturing
-- functions should need, AFAICT.


  grassthresh=11;
--grassthresh of ~96 works better for more noisy, randomly generated
-- heightfields (such as those made by plasmas and perlin noise in gimp),
-- as these will tend to have most area somewhere in the middle.

  if z<grassthresh then
--vaguely grassy pattern in grassy colours.
    y=y/2.5;
    my=sin(y*170);
    mx=sin((x+my)*184)*sin(y*170);
    m=ceil(4*mx);
    r=8-(m/4);
    g=64+(m);
    b=(z+(m/4)+2)/2;
  end
--don't forget this next step!!
  return r,g,b;
end
